import java.util.*;

public class DemoCollections {
    
    public static void stringListDemo() {
        List<String> names = new ArrayList<>();
        
        names.add("Jan");
        names.add("Karel");
        names.add("Pepa");
        names.add("Libor");
        names.add("Josef");
        
        names.add("Karel");
        
        names.add(null);
        names.add(null);
        
        names.add(0, "Radek");

        //System.out.println(names.size());
        /*
        for (int i = 0; i < names.size(); i++) {
            System.out.println(names.get(i));
        }
        */
       
        names.addAll(names);
        //if (names.contains("Pepa")) System.out.println("Pepa));
        

        /*
            if ("Pepa".equals(name)) names.remove("Pepa");
        }
        */
       
        for (int i = 0; i < names.size(); i++) {
            if ("Pepa".equals(names.get(i))) {
                names.remove(i);
                i--;
            }
        }
        
        for (Iterator<String> iter = names.iterator(); iter.hasNext(); ) {
            String name = iter.next();
            if ("Pepa".equals(name)) iter.remove();
        }
        
        while (names.contains("Pepa")) names.remove("Pepa");

        /*
        for (String name : names) {
            if ("Pepa".equals(name)) System.out.println(name);
        }
        */
       
       System.out.println(names);
    }    
    
    
    public static void stringSetDemo() {
        Set<String> names = new HashSet<>();
        
        names.add("Jan");
        names.add("Karel");
        names.add("Pepa");
        names.add("Libor");
        names.add("Josef");
        
        names.add("Karel");
        
        names.add(null);
        names.add(null);
        
        System.out.println(names);
    }
    
   
    
    
    
    
    
    
    
    
    
    public static void main(String[] args) {
        searchSetTest();
        searchListTest();
    }
    
    
    private static void searchSetTest() {
        Set<String> nameSet = new HashSet<String>();
        
        for(int i = 0; i < 30000; i++) {
            String s = "Retezec" + i;
            nameSet.add(s);
        }    
        
        long startTime = System.currentTimeMillis();
        int countInSet = 0;
        for(int i = 25000; i < 35000; i++) {
            String s = "Retezec" + i;
            if(nameSet.contains(s)) {
                countInSet++;
            }
        }    
        System.out.println("Count in set " + countInSet);
        long endTime = System.currentTimeMillis();
        
        System.out.println("Elapsed time set " + (endTime-startTime) + " ms.");
    }    
    
    private static void searchListTest() {
        List<String> nameList = new ArrayList<String>();
        
        for(int i = 0; i < 30000; i++) {
            String s = "Retezec" + i;
            nameList.add(s);
        }    
        
        long startTime = System.currentTimeMillis();
        int countInList = 0;
        for(int i = 25000; i < 35000; i++) {
            String s = "Retezec" + i;
            if(nameList.contains(s)) {
                countInList++;
            }
        }    
        System.out.println("Count in list " + countInList);
        long endTime = System.currentTimeMillis();
        
        System.out.println("Elapsed time list " + (endTime-startTime) + " ms.");
    } 
}
 
